export declare type Maybe<T> = T | null;
/** All built-in and custom scalars, mapped to their actual values */
export declare type Scalars = {
    ID: string;
    String: string;
    Boolean: boolean;
    Int: number;
    Float: number;
    AnyObject: any;
    JSON: any;
    JSONObject: any;
    Date: any;
    Time: any;
    DateTime: any;
};
export declare type ClientCounter = {
    counter?: Maybe<Scalars["Int"]>;
};
export declare type Counter = {
    amount: Scalars["Int"];
};
export declare type FieldError = {
    field: Scalars["String"];
    message: Scalars["String"];
};
export declare type Mutation = {
    dummy?: Maybe<Scalars["Int"]>;
    addCounterState?: Maybe<ClientCounter>;
    addCounter?: Maybe<Counter>;
};
export declare type MutationAddCounterStateArgs = {
    amount: Scalars["Int"];
};
export declare type MutationAddCounterArgs = {
    amount?: Maybe<Scalars["Int"]>;
};
export declare type Node = {
    id: Scalars["ID"];
};
export declare type Query = {
    dummy?: Maybe<Scalars["Int"]>;
    counterState?: Maybe<ClientCounter>;
    counter?: Maybe<Counter>;
};
export declare type Subscription = {
    dummy?: Maybe<Scalars["Int"]>;
    counterUpdated?: Maybe<Counter>;
};
export declare type AddCounterStateMutationVariables = {
    amount: Scalars["Int"];
};
export declare type AddCounterStateMutation = {
    __typename?: "Mutation";
} & {
    addCounterState: Maybe<{
        __typename?: "ClientCounter";
    } & Pick<ClientCounter, "counter">>;
};
export declare type AddCounterMutationVariables = {
    amount: Scalars["Int"];
};
export declare type AddCounterMutation = {
    __typename?: "Mutation";
} & {
    addCounter: Maybe<{
        __typename?: "Counter";
    } & Pick<Counter, "amount">>;
};
export declare type CounterStateQueryVariables = {};
export declare type CounterStateQuery = {
    __typename?: "Query";
} & {
    counterState: Maybe<{
        __typename?: "ClientCounter";
    } & Pick<ClientCounter, "counter">>;
};
export declare type CounterQueryQueryVariables = {};
export declare type CounterQueryQuery = {
    __typename?: "Query";
} & {
    counter: Maybe<{
        __typename?: "Counter";
    } & Pick<Counter, "amount">>;
};
export declare type OnCounterUpdatedSubscriptionVariables = {};
export declare type OnCounterUpdatedSubscription = {
    __typename?: "Subscription";
} & {
    counterUpdated: Maybe<{
        __typename?: "Counter";
    } & Pick<Counter, "amount">>;
};
import { MyContext } from "./interfaces/context";
import { GraphQLResolveInfo, GraphQLScalarType, GraphQLScalarTypeConfig } from "graphql";
export declare type ResolverFn<TResult, TParent, TContext, TArgs> = (parent: TParent, args: TArgs, context: TContext, info: GraphQLResolveInfo) => Promise<TResult> | TResult;
export declare type StitchingResolver<TResult, TParent, TContext, TArgs> = {
    fragment: string;
    resolve: ResolverFn<TResult, TParent, TContext, TArgs>;
};
export declare type Resolver<TResult, TParent = {}, TContext = {}, TArgs = {}> = ResolverFn<TResult, TParent, TContext, TArgs> | StitchingResolver<TResult, TParent, TContext, TArgs>;
export declare type SubscriptionSubscribeFn<TResult, TParent, TContext, TArgs> = (parent: TParent, args: TArgs, context: TContext, info: GraphQLResolveInfo) => AsyncIterator<TResult> | Promise<AsyncIterator<TResult>>;
export declare type SubscriptionResolveFn<TResult, TParent, TContext, TArgs> = (parent: TParent, args: TArgs, context: TContext, info: GraphQLResolveInfo) => TResult | Promise<TResult>;
export interface SubscriptionResolverObject<TResult, TParent, TContext, TArgs> {
    subscribe: SubscriptionSubscribeFn<TResult, TParent, TContext, TArgs>;
    resolve?: SubscriptionResolveFn<TResult, TParent, TContext, TArgs>;
}
export declare type SubscriptionResolver<TResult, TParent = {}, TContext = {}, TArgs = {}> = ((...args: any[]) => SubscriptionResolverObject<TResult, TParent, TContext, TArgs>) | SubscriptionResolverObject<TResult, TParent, TContext, TArgs>;
export declare type TypeResolveFn<TTypes, TParent = {}, TContext = {}> = (parent: TParent, context: TContext, info: GraphQLResolveInfo) => Maybe<TTypes>;
export declare type NextResolverFn<T> = () => Promise<T>;
export declare type DirectiveResolverFn<TResult = {}, TParent = {}, TContext = {}, TArgs = {}> = (next: NextResolverFn<TResult>, parent: TParent, args: TArgs, context: TContext, info: GraphQLResolveInfo) => TResult | Promise<TResult>;
/** Mapping between all available schema types and the resolvers types */
export declare type ResolversTypes = {
    Query: {};
    Int: Scalars["Int"];
    ClientCounter: ClientCounter;
    Counter: Counter;
    Mutation: {};
    Subscription: {};
    String: Scalars["String"];
    Boolean: Scalars["Boolean"];
    AnyObject: Scalars["AnyObject"];
    JSON: Scalars["JSON"];
    JSONObject: Scalars["JSONObject"];
    FieldError: FieldError;
    Node: Node;
    ID: Scalars["ID"];
    Date: Scalars["Date"];
    Time: Scalars["Time"];
    DateTime: Scalars["DateTime"];
};
export interface AnyObjectScalarConfig extends GraphQLScalarTypeConfig<ResolversTypes["AnyObject"], any> {
    name: "AnyObject";
}
export declare type ClientCounterResolvers<ContextType = MyContext, ParentType = ResolversTypes["ClientCounter"]> = {
    counter?: Resolver<Maybe<ResolversTypes["Int"]>, ParentType, ContextType>;
};
export declare type CounterResolvers<ContextType = MyContext, ParentType = ResolversTypes["Counter"]> = {
    amount?: Resolver<ResolversTypes["Int"], ParentType, ContextType>;
};
export interface DateScalarConfig extends GraphQLScalarTypeConfig<ResolversTypes["Date"], any> {
    name: "Date";
}
export interface DateTimeScalarConfig extends GraphQLScalarTypeConfig<ResolversTypes["DateTime"], any> {
    name: "DateTime";
}
export declare type FieldErrorResolvers<ContextType = MyContext, ParentType = ResolversTypes["FieldError"]> = {
    field?: Resolver<ResolversTypes["String"], ParentType, ContextType>;
    message?: Resolver<ResolversTypes["String"], ParentType, ContextType>;
};
export interface JsonScalarConfig extends GraphQLScalarTypeConfig<ResolversTypes["JSON"], any> {
    name: "JSON";
}
export interface JsonObjectScalarConfig extends GraphQLScalarTypeConfig<ResolversTypes["JSONObject"], any> {
    name: "JSONObject";
}
export declare type MutationResolvers<ContextType = MyContext, ParentType = ResolversTypes["Mutation"]> = {
    dummy?: Resolver<Maybe<ResolversTypes["Int"]>, ParentType, ContextType>;
    addCounterState?: Resolver<Maybe<ResolversTypes["ClientCounter"]>, ParentType, ContextType, MutationAddCounterStateArgs>;
    addCounter?: Resolver<Maybe<ResolversTypes["Counter"]>, ParentType, ContextType, MutationAddCounterArgs>;
};
export declare type NodeResolvers<ContextType = MyContext, ParentType = ResolversTypes["Node"]> = {
    __resolveType: TypeResolveFn<null, ParentType, ContextType>;
    id?: Resolver<ResolversTypes["ID"], ParentType, ContextType>;
};
export declare type QueryResolvers<ContextType = MyContext, ParentType = ResolversTypes["Query"]> = {
    dummy?: Resolver<Maybe<ResolversTypes["Int"]>, ParentType, ContextType>;
    counterState?: Resolver<Maybe<ResolversTypes["ClientCounter"]>, ParentType, ContextType>;
    counter?: Resolver<Maybe<ResolversTypes["Counter"]>, ParentType, ContextType>;
};
export declare type SubscriptionResolvers<ContextType = MyContext, ParentType = ResolversTypes["Subscription"]> = {
    dummy?: SubscriptionResolver<Maybe<ResolversTypes["Int"]>, ParentType, ContextType>;
    counterUpdated?: SubscriptionResolver<Maybe<ResolversTypes["Counter"]>, ParentType, ContextType>;
};
export interface TimeScalarConfig extends GraphQLScalarTypeConfig<ResolversTypes["Time"], any> {
    name: "Time";
}
export declare type Resolvers<ContextType = MyContext> = {
    AnyObject?: GraphQLScalarType;
    ClientCounter?: ClientCounterResolvers<ContextType>;
    Counter?: CounterResolvers<ContextType>;
    Date?: GraphQLScalarType;
    DateTime?: GraphQLScalarType;
    FieldError?: FieldErrorResolvers<ContextType>;
    JSON?: GraphQLScalarType;
    JSONObject?: GraphQLScalarType;
    Mutation?: MutationResolvers<ContextType>;
    Node?: NodeResolvers;
    Query?: QueryResolvers<ContextType>;
    Subscription?: SubscriptionResolvers<ContextType>;
    Time?: GraphQLScalarType;
};
/**
 * @deprecated
 * Use "Resolvers" root object instead. If you wish to get "IResolvers", add "typesPrefix: I" to your config.
 */
export declare type IResolvers<ContextType = MyContext> = Resolvers<ContextType>;
export declare type Omit<T, K extends keyof T> = Pick<T, Exclude<keyof T, K>>;
export declare const AddCounterStateDocument: any;
export declare const AddCounterDocument: any;
export declare const CounterStateDocument: any;
export declare const CounterQueryDocument: any;
export declare const OnCounterUpdatedDocument: any;
